variable "public_network_name" {}

terraform {
required_version = ">= 0.14.0"
  required_providers {
    openstack = {
      source  = "terraform-provider-openstack/openstack"
      version = "~> 1.42.0"
    }
  }
}

provider "openstack" {
  use_octavia         = true
  endpoint_overrides = {
      "network"  = "https://neutron-api.cloud.rc.uab.edu:9696/v2.0/"
    }
}


# defines where floating ip will come from using variable public_network_name defined in root module
resource "openstack_networking_floatingip_v2" "ohpc_ip" {
  pool = var.public_network_name
}

resource "openstack_networking_floatingip_v2" "ood_ip" {
  pool = var.public_network_name
}

output "ohpc_address" {
  value = openstack_networking_floatingip_v2.ohpc_ip.address
}

output "ood_address" {
  value = openstack_networking_floatingip_v2.ood_ip.address
}
