variable "keypair_name" {}
variable "ssh_public_key" {}

terraform {
required_version = ">= 0.14.0"
  required_providers {
    openstack = {
      source  = "terraform-provider-openstack/openstack"
      version = "~> 1.42.0"
    }
  }
}

provider "openstack" {
  use_octavia         = true
  endpoint_overrides = {
      "network"  = "https://neutron-api.cloud.rc.uab.edu:9696/v2.0/"
    }
}

resource "openstack_compute_keypair_v2" "keypair" {
  name       = var.keypair_name
  public_key = var.ssh_public_key
}

output "keypair_name" {
    value = var.keypair_name
}

output "public_key" {
    value = var.ssh_public_key
}
